// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-fx-dtos.proto

package com.accelfin.server.demo.fx.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto}
 */
public  final class FxHistoricalTradeDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto)
    FxHistoricalTradeDtoOrBuilder {
  // Use FxHistoricalTradeDto.newBuilder() to construct.
  private FxHistoricalTradeDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private FxHistoricalTradeDto() {
    tradeId_ = "";
    currencyPair_ = "";
    side_ = 0;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private FxHistoricalTradeDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            tradeId_ = s;
            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            currencyPair_ = s;
            break;
          }
          case 26: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (notional_ != null) {
              subBuilder = notional_.toBuilder();
            }
            notional_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(notional_);
              notional_ = subBuilder.buildPartial();
            }

            break;
          }
          case 32: {
            int rawValue = input.readEnum();

            side_ = rawValue;
            break;
          }
          case 42: {
            com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.Builder subBuilder = null;
            if (price_ != null) {
              subBuilder = price_.toBuilder();
            }
            price_ = input.readMessage(com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(price_);
              price_ = subBuilder.buildPartial();
            }

            break;
          }
          case 50: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (executedRate_ != null) {
              subBuilder = executedRate_.toBuilder();
            }
            executedRate_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(executedRate_);
              executedRate_ = subBuilder.buildPartial();
            }

            break;
          }
          case 58: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (executedAt_ != null) {
              subBuilder = executedAt_.toBuilder();
            }
            executedAt_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(executedAt_);
              executedAt_ = subBuilder.buildPartial();
            }

            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxHistoricalTradeDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxHistoricalTradeDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.class, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder.class);
  }

  public static final int TRADEID_FIELD_NUMBER = 1;
  private volatile java.lang.Object tradeId_;
  /**
   * <code>optional string tradeId = 1;</code>
   */
  public java.lang.String getTradeId() {
    java.lang.Object ref = tradeId_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      tradeId_ = s;
      return s;
    }
  }
  /**
   * <code>optional string tradeId = 1;</code>
   */
  public com.google.protobuf.ByteString
      getTradeIdBytes() {
    java.lang.Object ref = tradeId_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      tradeId_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CURRENCY_PAIR_FIELD_NUMBER = 2;
  private volatile java.lang.Object currencyPair_;
  /**
   * <code>optional string currency_pair = 2;</code>
   */
  public java.lang.String getCurrencyPair() {
    java.lang.Object ref = currencyPair_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      currencyPair_ = s;
      return s;
    }
  }
  /**
   * <code>optional string currency_pair = 2;</code>
   */
  public com.google.protobuf.ByteString
      getCurrencyPairBytes() {
    java.lang.Object ref = currencyPair_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      currencyPair_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int NOTIONAL_FIELD_NUMBER = 3;
  private com.accelfin.server.messaging.dtos.DecimalDto notional_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
   */
  public boolean hasNotional() {
    return notional_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getNotional() {
    return notional_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : notional_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getNotionalOrBuilder() {
    return getNotional();
  }

  public static final int SIDE_FIELD_NUMBER = 4;
  private int side_;
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
   */
  public int getSideValue() {
    return side_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
   */
  public com.accelfin.server.demo.fx.dtos.SideDto getSide() {
    com.accelfin.server.demo.fx.dtos.SideDto result = com.accelfin.server.demo.fx.dtos.SideDto.forNumber(side_);
    return result == null ? com.accelfin.server.demo.fx.dtos.SideDto.UNRECOGNIZED : result;
  }

  public static final int PRICE_FIELD_NUMBER = 5;
  private com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price_;
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
   */
  public boolean hasPrice() {
    return price_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
   */
  public com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto getPrice() {
    return price_ == null ? com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.getDefaultInstance() : price_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
   */
  public com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDtoOrBuilder getPriceOrBuilder() {
    return getPrice();
  }

  public static final int EXECUTED_RATE_FIELD_NUMBER = 6;
  private com.accelfin.server.messaging.dtos.DecimalDto executedRate_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
   */
  public boolean hasExecutedRate() {
    return executedRate_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getExecutedRate() {
    return executedRate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : executedRate_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getExecutedRateOrBuilder() {
    return getExecutedRate();
  }

  public static final int EXECUTED_AT_FIELD_NUMBER = 7;
  private com.accelfin.server.messaging.dtos.TimestampDto executedAt_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
   */
  public boolean hasExecutedAt() {
    return executedAt_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getExecutedAt() {
    return executedAt_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : executedAt_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getExecutedAtOrBuilder() {
    return getExecutedAt();
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getTradeIdBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, tradeId_);
    }
    if (!getCurrencyPairBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 2, currencyPair_);
    }
    if (notional_ != null) {
      output.writeMessage(3, getNotional());
    }
    if (side_ != com.accelfin.server.demo.fx.dtos.SideDto.BUY.getNumber()) {
      output.writeEnum(4, side_);
    }
    if (price_ != null) {
      output.writeMessage(5, getPrice());
    }
    if (executedRate_ != null) {
      output.writeMessage(6, getExecutedRate());
    }
    if (executedAt_ != null) {
      output.writeMessage(7, getExecutedAt());
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getTradeIdBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, tradeId_);
    }
    if (!getCurrencyPairBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(2, currencyPair_);
    }
    if (notional_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getNotional());
    }
    if (side_ != com.accelfin.server.demo.fx.dtos.SideDto.BUY.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(4, side_);
    }
    if (price_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getPrice());
    }
    if (executedRate_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getExecutedRate());
    }
    if (executedAt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getExecutedAt());
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto)
      com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxHistoricalTradeDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxHistoricalTradeDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.class, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      tradeId_ = "";

      currencyPair_ = "";

      if (notionalBuilder_ == null) {
        notional_ = null;
      } else {
        notional_ = null;
        notionalBuilder_ = null;
      }
      side_ = 0;

      if (priceBuilder_ == null) {
        price_ = null;
      } else {
        price_ = null;
        priceBuilder_ = null;
      }
      if (executedRateBuilder_ == null) {
        executedRate_ = null;
      } else {
        executedRate_ = null;
        executedRateBuilder_ = null;
      }
      if (executedAtBuilder_ == null) {
        executedAt_ = null;
      } else {
        executedAt_ = null;
        executedAtBuilder_ = null;
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxHistoricalTradeDto_descriptor;
    }

    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto build() {
      com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto buildPartial() {
      com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto result = new com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto(this);
      result.tradeId_ = tradeId_;
      result.currencyPair_ = currencyPair_;
      if (notionalBuilder_ == null) {
        result.notional_ = notional_;
      } else {
        result.notional_ = notionalBuilder_.build();
      }
      result.side_ = side_;
      if (priceBuilder_ == null) {
        result.price_ = price_;
      } else {
        result.price_ = priceBuilder_.build();
      }
      if (executedRateBuilder_ == null) {
        result.executedRate_ = executedRate_;
      } else {
        result.executedRate_ = executedRateBuilder_.build();
      }
      if (executedAtBuilder_ == null) {
        result.executedAt_ = executedAt_;
      } else {
        result.executedAt_ = executedAtBuilder_.build();
      }
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto) {
        return mergeFrom((com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto other) {
      if (other == com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.getDefaultInstance()) return this;
      if (!other.getTradeId().isEmpty()) {
        tradeId_ = other.tradeId_;
        onChanged();
      }
      if (!other.getCurrencyPair().isEmpty()) {
        currencyPair_ = other.currencyPair_;
        onChanged();
      }
      if (other.hasNotional()) {
        mergeNotional(other.getNotional());
      }
      if (other.side_ != 0) {
        setSideValue(other.getSideValue());
      }
      if (other.hasPrice()) {
        mergePrice(other.getPrice());
      }
      if (other.hasExecutedRate()) {
        mergeExecutedRate(other.getExecutedRate());
      }
      if (other.hasExecutedAt()) {
        mergeExecutedAt(other.getExecutedAt());
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private java.lang.Object tradeId_ = "";
    /**
     * <code>optional string tradeId = 1;</code>
     */
    public java.lang.String getTradeId() {
      java.lang.Object ref = tradeId_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        tradeId_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string tradeId = 1;</code>
     */
    public com.google.protobuf.ByteString
        getTradeIdBytes() {
      java.lang.Object ref = tradeId_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        tradeId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string tradeId = 1;</code>
     */
    public Builder setTradeId(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      tradeId_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string tradeId = 1;</code>
     */
    public Builder clearTradeId() {
      
      tradeId_ = getDefaultInstance().getTradeId();
      onChanged();
      return this;
    }
    /**
     * <code>optional string tradeId = 1;</code>
     */
    public Builder setTradeIdBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      tradeId_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object currencyPair_ = "";
    /**
     * <code>optional string currency_pair = 2;</code>
     */
    public java.lang.String getCurrencyPair() {
      java.lang.Object ref = currencyPair_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        currencyPair_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string currency_pair = 2;</code>
     */
    public com.google.protobuf.ByteString
        getCurrencyPairBytes() {
      java.lang.Object ref = currencyPair_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        currencyPair_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string currency_pair = 2;</code>
     */
    public Builder setCurrencyPair(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      currencyPair_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string currency_pair = 2;</code>
     */
    public Builder clearCurrencyPair() {
      
      currencyPair_ = getDefaultInstance().getCurrencyPair();
      onChanged();
      return this;
    }
    /**
     * <code>optional string currency_pair = 2;</code>
     */
    public Builder setCurrencyPairBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      currencyPair_ = value;
      onChanged();
      return this;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto notional_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> notionalBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public boolean hasNotional() {
      return notionalBuilder_ != null || notional_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getNotional() {
      if (notionalBuilder_ == null) {
        return notional_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : notional_;
      } else {
        return notionalBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public Builder setNotional(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (notionalBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        notional_ = value;
        onChanged();
      } else {
        notionalBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public Builder setNotional(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (notionalBuilder_ == null) {
        notional_ = builderForValue.build();
        onChanged();
      } else {
        notionalBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public Builder mergeNotional(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (notionalBuilder_ == null) {
        if (notional_ != null) {
          notional_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(notional_).mergeFrom(value).buildPartial();
        } else {
          notional_ = value;
        }
        onChanged();
      } else {
        notionalBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public Builder clearNotional() {
      if (notionalBuilder_ == null) {
        notional_ = null;
        onChanged();
      } else {
        notional_ = null;
        notionalBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getNotionalBuilder() {
      
      onChanged();
      return getNotionalFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getNotionalOrBuilder() {
      if (notionalBuilder_ != null) {
        return notionalBuilder_.getMessageOrBuilder();
      } else {
        return notional_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : notional_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto notional = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getNotionalFieldBuilder() {
      if (notionalBuilder_ == null) {
        notionalBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getNotional(),
                getParentForChildren(),
                isClean());
        notional_ = null;
      }
      return notionalBuilder_;
    }

    private int side_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public int getSideValue() {
      return side_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public Builder setSideValue(int value) {
      side_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public com.accelfin.server.demo.fx.dtos.SideDto getSide() {
      com.accelfin.server.demo.fx.dtos.SideDto result = com.accelfin.server.demo.fx.dtos.SideDto.forNumber(side_);
      return result == null ? com.accelfin.server.demo.fx.dtos.SideDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public Builder setSide(com.accelfin.server.demo.fx.dtos.SideDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      side_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.SideDto side = 4;</code>
     */
    public Builder clearSide() {
      
      side_ = 0;
      onChanged();
      return this;
    }

    private com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto, com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.Builder, com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDtoOrBuilder> priceBuilder_;
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public boolean hasPrice() {
      return priceBuilder_ != null || price_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto getPrice() {
      if (priceBuilder_ == null) {
        return price_ == null ? com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.getDefaultInstance() : price_;
      } else {
        return priceBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public Builder setPrice(com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto value) {
      if (priceBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        price_ = value;
        onChanged();
      } else {
        priceBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public Builder setPrice(
        com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.Builder builderForValue) {
      if (priceBuilder_ == null) {
        price_ = builderForValue.build();
        onChanged();
      } else {
        priceBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public Builder mergePrice(com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto value) {
      if (priceBuilder_ == null) {
        if (price_ != null) {
          price_ =
            com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.newBuilder(price_).mergeFrom(value).buildPartial();
        } else {
          price_ = value;
        }
        onChanged();
      } else {
        priceBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public Builder clearPrice() {
      if (priceBuilder_ == null) {
        price_ = null;
        onChanged();
      } else {
        price_ = null;
        priceBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.Builder getPriceBuilder() {
      
      onChanged();
      return getPriceFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDtoOrBuilder getPriceOrBuilder() {
      if (priceBuilder_ != null) {
        return priceBuilder_.getMessageOrBuilder();
      } else {
        return price_ == null ?
            com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.getDefaultInstance() : price_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto price = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto, com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.Builder, com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDtoOrBuilder> 
        getPriceFieldBuilder() {
      if (priceBuilder_ == null) {
        priceBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto, com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDto.Builder, com.accelfin.server.demo.fx.dtos.FxHistoricalPriceDtoOrBuilder>(
                getPrice(),
                getParentForChildren(),
                isClean());
        price_ = null;
      }
      return priceBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto executedRate_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> executedRateBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public boolean hasExecutedRate() {
      return executedRateBuilder_ != null || executedRate_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getExecutedRate() {
      if (executedRateBuilder_ == null) {
        return executedRate_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : executedRate_;
      } else {
        return executedRateBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public Builder setExecutedRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (executedRateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        executedRate_ = value;
        onChanged();
      } else {
        executedRateBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public Builder setExecutedRate(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (executedRateBuilder_ == null) {
        executedRate_ = builderForValue.build();
        onChanged();
      } else {
        executedRateBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public Builder mergeExecutedRate(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (executedRateBuilder_ == null) {
        if (executedRate_ != null) {
          executedRate_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(executedRate_).mergeFrom(value).buildPartial();
        } else {
          executedRate_ = value;
        }
        onChanged();
      } else {
        executedRateBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public Builder clearExecutedRate() {
      if (executedRateBuilder_ == null) {
        executedRate_ = null;
        onChanged();
      } else {
        executedRate_ = null;
        executedRateBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getExecutedRateBuilder() {
      
      onChanged();
      return getExecutedRateFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getExecutedRateOrBuilder() {
      if (executedRateBuilder_ != null) {
        return executedRateBuilder_.getMessageOrBuilder();
      } else {
        return executedRate_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : executedRate_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto executed_rate = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getExecutedRateFieldBuilder() {
      if (executedRateBuilder_ == null) {
        executedRateBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getExecutedRate(),
                getParentForChildren(),
                isClean());
        executedRate_ = null;
      }
      return executedRateBuilder_;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto executedAt_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> executedAtBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public boolean hasExecutedAt() {
      return executedAtBuilder_ != null || executedAt_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getExecutedAt() {
      if (executedAtBuilder_ == null) {
        return executedAt_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : executedAt_;
      } else {
        return executedAtBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public Builder setExecutedAt(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (executedAtBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        executedAt_ = value;
        onChanged();
      } else {
        executedAtBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public Builder setExecutedAt(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (executedAtBuilder_ == null) {
        executedAt_ = builderForValue.build();
        onChanged();
      } else {
        executedAtBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public Builder mergeExecutedAt(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (executedAtBuilder_ == null) {
        if (executedAt_ != null) {
          executedAt_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(executedAt_).mergeFrom(value).buildPartial();
        } else {
          executedAt_ = value;
        }
        onChanged();
      } else {
        executedAtBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public Builder clearExecutedAt() {
      if (executedAtBuilder_ == null) {
        executedAt_ = null;
        onChanged();
      } else {
        executedAt_ = null;
        executedAtBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getExecutedAtBuilder() {
      
      onChanged();
      return getExecutedAtFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getExecutedAtOrBuilder() {
      if (executedAtBuilder_ != null) {
        return executedAtBuilder_.getMessageOrBuilder();
      } else {
        return executedAt_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : executedAt_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto executed_at = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getExecutedAtFieldBuilder() {
      if (executedAtBuilder_ == null) {
        executedAtBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getExecutedAt(),
                getParentForChildren(),
                isClean());
        executedAt_ = null;
      }
      return executedAtBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto)
  private static final com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto();
  }

  public static com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FxHistoricalTradeDto>
      PARSER = new com.google.protobuf.AbstractParser<FxHistoricalTradeDto>() {
    public FxHistoricalTradeDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new FxHistoricalTradeDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<FxHistoricalTradeDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FxHistoricalTradeDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

